// main.cpp -- skeleton created by new.main

/*
 *   sortSlots \$UIFILE
 *    sorts the slots in a ui file for easier lookups of slots 
 *    in the signal slot editor
 * 
 *  writeCpp \$UIFILE
 *    writes slot templates for the file named like the $UIFILE
 *    but with the '.cpp' file extension.
 *    
 *  writeH \$UIFILE
 *    writes slot templates for the file named like the $UIFILE
 *    but with the '.h' file extension.
 * 
 *  listSlots \$UIFILE
 *    Shows slots found in the \$UIFILE
 * 
 *  listSignals \$UIFILE
 *    Shows signals found in the \$UIFILE
 * 
 *  commands
 *    shows this list and usage notes.
 * 
 *  help
 *    Displays a simple help message in a message box
 */

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <QApplication>
#include "ui-tool.h"
#include "dict-util.h"  // find and do_cmd

void dbg(){} // for a non-moving breakpoint

// returns index or -1 if not found
int find_command(const char* cmd);
void do_cmd(int cmd_index, char** args);

int g_argc;
char** g_argv;

int main(int argc, char** argv)
{
  dbg();

  // export input args for ui2cpp to work
  g_argc = argc;
  g_argv = argv;
  
  new QApplication(argc, argv); // creates global qApp  
  
  if(argc < 2)
    return usage(1);
  
  char* cmd;
  cmd = strrchr(argv[1], '-');
  
  if(!cmd)
    cmd = argv[1];
  else
    cmd++;
        
  int cmd_index = find_command(cmd);
  if(cmd_index < 0)
  {
    fprintf(stderr, "Can't find the command '%s' in my dictionary\n", cmd);
    return 1;
  }
  do_cmd(cmd_index, argv + 1);
  
  return 0;
}

